(* catch_em_all.ml: Not_found exception is caught and all other kinds
   of exceptions during the main loop are caught via a "catch-all"
   exception handler including the end of file exception. *)

open Printf;;
open Print_kind;;
  
let _ =
  let quit_now = ref false in
  while not !quit_now do
    try                           (* begin try *)
      printf "query: ";           
      let pok = read_line () in   (* may throw End_of_file *)
      if pok="quit" then          
        quit_now := true         
      else                        
        print_kind3 pok;          (* may throw Not_found *)
    with                          (* exc handling *)
    | Not_found -> printf "Oops!\n";
    | End_of_file -> printf "Catch more!\n"
    | exc ->                      (* catch any other exception *)
       printf "\nSomething went wrong somewhere!\n";
       let excstr = Printexc.to_string exc in
       printf "Exception: %s\n" excstr;
  done;
;;
