(* inner_catch.ml: print_kind3 raises an exception which is
   caught. Not_found exception handling covers only that call. *)

open Printf;;
open Print_kind;;

(* main loop which asks for repeated input *)
let _ =
  let quit_now = ref false in
  while not !quit_now do
      printf "query: ";
      let pok = read_line () in
      if pok="quit" then
        quit_now := true
      else
        try                     (* begin try *)
          print_kind3 pok       (* may throw *)
        with                    (* exc handling *)
        | Not_found -> printf "Oops!\n";
  done;
;;
