(* print_kind.ml: demonstrate assoc operations with options retured in
   print_kind1 vs exeception handling in print_kind2. print_kind3
   calls assoc with a catch which can crash a program. *)

open Printf;;
open List;;

let alist = [("Bulbasaur"  ,"Grass");
             ("Squirtle"   ,"Water");
             ("Charmander" ,"Fire");]
;;

(* look up kind using assoc_opt *)
let print_kind1 pok =
  printf "%s: " pok;
  let result = assoc_opt pok alist in
  match result with
  | None       -> printf "Unknown\n"
  | Some(kind) -> printf "%s\n" kind
;;

(* look up kind using assoc; catch exceptions *)
let print_kind2 pok =
  printf "%s: " pok;
  try 
    let kind = assoc pok alist in
    printf "%s\n" kind;
  with
  | Not_found -> printf "Unknown\n"
;;
  
(* look up kind but don't catch exceptions *)
let print_kind3 pok =
  printf "%s: " pok;
  let kind = assoc pok alist in
  printf "%s\n" kind;
;;
