(* separate_catch.ml: print_kind3 and read_line can raise exceptions,
   handle them in separate blocks. *)

open Printf;;
open Print_kind;;

(* main loop which asks for repeated input *)
let _ =
  let quit_now = ref false in
  while not !quit_now do
      printf "query: ";
      let pok =
        try                     (* begin try *)
          read_line ()          (* may throw *)
        with                    (* exc handling *)
        | End_of_file -> "Default"
      in
      if pok="quit" then
        quit_now := true
      else
        try                     (* begin try *)
          print_kind3 pok       (* may throw *)
        with                    (* exc handling *)
        | Not_found -> printf "Oops!\n";
  done;
;;
